DROP TABLE IF EXISTS USERS;
CREATE TABLE USERS
(
    ID          SERIAL,
    USERNAME    VARCHAR(100) NOT NULL,
    EMAIL       VARCHAR(100) NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX USERNAME_UNIQUE ON USERS (USERNAME);
CREATE UNIQUE INDEX USER_EMAIL_UNIQUE ON USERS (EMAIL) WHERE EMAIL IS NOT NULL;
CREATE TRIGGER UPDATE_TIMESTAMP_USERS
    BEFORE INSERT OR UPDATE
    ON USERS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS TEST_SUITES;
CREATE TABLE IF NOT EXISTS TEST_SUITES
(
    ID          SERIAL,
    NAME        VARCHAR(200) NOT NULL,
    DESCRIPTION TEXT         NULL,
    FILE_NAME   VARCHAR(255) NOT NULL DEFAULT '',
    USER_ID     INT          NOT NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (USER_ID) REFERENCES USERS (ID)
);
CREATE UNIQUE INDEX NAME_FILE_USER_UNIQUE ON TEST_SUITES (NAME, FILE_NAME, USER_ID);
CREATE INDEX FK_TEST_SUITE_USER_ASC ON TEST_SUITES (USER_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_TEST_SUITS
    BEFORE INSERT OR UPDATE
    ON TEST_SUITES
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS PROJECTS;
CREATE TABLE IF NOT EXISTS PROJECTS
(
    ID          SERIAL,
    NAME        VARCHAR(255) NOT NULL,
    DESCRIPTION TEXT         NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX NAME_UNIQUE ON PROJECTS (NAME);
CREATE TRIGGER UPDATE_TIMESTAMP_PROJECTS
    BEFORE INSERT OR UPDATE
    ON PROJECTS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS TEST_CASES;
CREATE TABLE IF NOT EXISTS TEST_CASES
(
    ID                 SERIAL,
    TEST_CLASS         VARCHAR(255) NOT NULL,
    TEST_METHOD        VARCHAR(255) NOT NULL,
    INFO               TEXT         NULL,
    TEST_SUITE_ID      INT          NOT NULL,
    PRIMARY_OWNER_ID   INT          NOT NULL,
    SECONDARY_OWNER_ID INT          NULL,
    PROJECT_ID         INT          NULL,
    STATUS             VARCHAR(20)  NOT NULL DEFAULT 'UNKNOWN',
    MODIFIED_AT        TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT         TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_SUITE_ID) REFERENCES TEST_SUITES (ID),
    FOREIGN KEY (PRIMARY_OWNER_ID) REFERENCES USERS (ID),
    FOREIGN KEY (SECONDARY_OWNER_ID) REFERENCES USERS (ID),
    FOREIGN KEY (PROJECT_ID) REFERENCES PROJECTS (ID)
);
CREATE INDEX FK_TEST_CASE_SUITE_ASC ON TEST_CASES (TEST_SUITE_ID);
CREATE INDEX FK_TEST_CASE_PRIMARY_OWNER_ASC ON TEST_CASES (PRIMARY_OWNER_ID);
CREATE INDEX FK_TEST_CASE_SECONDARY_OWNER_ASC ON TEST_CASES (SECONDARY_OWNER_ID);
CREATE INDEX FK_TEST_CASES_PROJECTS_ASC ON TEST_CASES (PROJECT_ID);
CREATE INDEX TESTCASES_TEST_CLASS_INDEX ON TEST_CASES (TEST_CLASS);
CREATE INDEX TESTCASES_TEST_METHOD_INDEX ON TEST_CASES (TEST_METHOD);
CREATE UNIQUE INDEX TESTCASES_OWNERSHIP_UNIQUE ON TEST_CASES (PRIMARY_OWNER_ID, TEST_CLASS, TEST_METHOD, PROJECT_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_TEST_CASES
    BEFORE INSERT OR UPDATE
    ON TEST_CASES
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS WORK_ITEMS;
CREATE TABLE IF NOT EXISTS WORK_ITEMS
(
    ID           SERIAL,
    JIRA_ID      VARCHAR(45) NOT NULL,
    TYPE         VARCHAR(45) NOT NULL DEFAULT 'TASK',
    HASH_CODE    INT         NULL,
    DESCRIPTION  TEXT        NULL,
    USER_ID      INT         NULL,
    TEST_CASE_ID INT         NULL,
    KNOWN_ISSUE  BOOLEAN     NOT NULL DEFAULT FALSE,
    BLOCKER      BOOLEAN     NOT NULL DEFAULT FALSE,
    MODIFIED_AT  TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT   TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (USER_ID) REFERENCES USERS (ID),
    FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASES (ID)
);
CREATE UNIQUE INDEX WORK_ITEM_UNIQUE ON WORK_ITEMS (JIRA_ID, TYPE, HASH_CODE);
CREATE INDEX FK_WORK_ITEM_USER_ASC ON WORK_ITEMS (USER_ID);
CREATE INDEX FK_WORK_ITEM_TEST_CASE_ASC ON WORK_ITEMS (TEST_CASE_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_WORK_ITEMS
    BEFORE INSERT OR UPDATE
    ON WORK_ITEMS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();
CREATE INDEX WORK_ITEMS_CREATED_AT_INDEX ON WORK_ITEMS (CREATED_AT);


DROP TABLE IF EXISTS INTEGRATION_GROUPS;
CREATE TABLE IF NOT EXISTS INTEGRATION_GROUPS
(
    ID               SERIAL,
    NAME             VARCHAR(50)  NOT NULL,
    DISPLAY_NAME     VARCHAR(50)  NOT NULL,
    ICON_URL         VARCHAR(255) NOT NULL,
    MULTIPLE_ALLOWED BOOLEAN      NOT NULL DEFAULT FALSE,
    MODIFIED_AT      TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT       TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX INTEGRATION_GROUPS_NAME_UNIQUE ON INTEGRATION_GROUPS (NAME);
CREATE TRIGGER UPDATE_TIMESTAMP_INTEGRATION_GROUPS
    BEFORE INSERT OR UPDATE
    ON INTEGRATION_GROUPS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS INTEGRATION_TYPES;
CREATE TABLE IF NOT EXISTS INTEGRATION_TYPES
(
    ID                   SERIAL,
    NAME                 VARCHAR(50)  NOT NULL,
    DISPLAY_NAME         VARCHAR(50)  NOT NULL,
    ICON_URL             VARCHAR(255) NOT NULL,
    INTEGRATION_GROUP_ID INT          NOT NULL,
    MODIFIED_AT          TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT           TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (INTEGRATION_GROUP_ID) REFERENCES INTEGRATION_GROUPS (ID)
);
CREATE UNIQUE INDEX INTEGRATION_TYPES_NAME_UNIQUE ON INTEGRATION_TYPES (NAME);
CREATE UNIQUE INDEX INTEGRATION_TYPES_DISPLAY_NAME_UNIQUE ON INTEGRATION_TYPES (DISPLAY_NAME);
CREATE TRIGGER UPDATE_TIMESTAMP_INTEGRATION_TYPES
    BEFORE INSERT OR UPDATE
    ON INTEGRATION_TYPES
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS INTEGRATIONS;
CREATE TABLE IF NOT EXISTS INTEGRATIONS
(
    ID                  SERIAL,
    NAME                VARCHAR(50) NOT NULL,
    BACK_REFERENCE_ID   VARCHAR(50) NULL,
    IS_DEFAULT          BOOLEAN     NOT NULL DEFAULT FALSE,
    ENABLED             BOOLEAN     NOT NULL DEFAULT FALSE,
    INTEGRATION_TYPE_ID INT         NOT NULL,
    MODIFIED_AT         TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT          TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (INTEGRATION_TYPE_ID) REFERENCES INTEGRATION_TYPES (ID)
);
CREATE UNIQUE INDEX INTEGRATIONS_BACK_REFERENCE_UNIQUE ON INTEGRATIONS (BACK_REFERENCE_ID);
CREATE UNIQUE INDEX INTEGRATIONS_INTEGRATION_TYPE_ID_DEFAULT_UNIQUE ON INTEGRATIONS (INTEGRATION_TYPE_ID, IS_DEFAULT) WHERE IS_DEFAULT = TRUE;
CREATE TRIGGER UPDATE_TIMESTAMP_INTEGRATIONS
    BEFORE INSERT OR UPDATE
    ON INTEGRATIONS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS INTEGRATION_PARAMS;
CREATE TABLE IF NOT EXISTS INTEGRATION_PARAMS
(
    ID                  SERIAL,
    NAME                VARCHAR(50) NOT NULL,
    METADATA            TEXT        NULL,
    DEFAULT_VALUE       TEXT        NULL,
    MANDATORY           BOOLEAN     NOT NULL DEFAULT FALSE,
    NEED_ENCRYPTION     BOOLEAN     NOT NULL DEFAULT FALSE,
    INTEGRATION_TYPE_ID INT         NOT NULL,
    MODIFIED_AT         TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT          TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (INTEGRATION_TYPE_ID) REFERENCES INTEGRATION_TYPES (ID)
);
CREATE UNIQUE INDEX INTEGRATION_PARAMS_NAME_INTEGRATION_TYPE_ID_UNIQUE ON INTEGRATION_PARAMS (NAME, INTEGRATION_TYPE_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_INTEGRATION_PARAMS
    BEFORE INSERT OR UPDATE
    ON INTEGRATION_PARAMS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS INTEGRATION_SETTINGS;
CREATE TABLE IF NOT EXISTS INTEGRATION_SETTINGS
(
    ID                   SERIAL,
    VALUE                TEXT      NULL,
    BINARY_DATA          BYTEA     NULL,
    ENCRYPTED            BOOLEAN   NOT NULL DEFAULT FALSE,
    INTEGRATION_ID       INT       NOT NULL,
    INTEGRATION_PARAM_ID INT       NOT NULL,
    MODIFIED_AT          TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT           TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (INTEGRATION_ID) REFERENCES INTEGRATIONS (ID),
    FOREIGN KEY (INTEGRATION_PARAM_ID) REFERENCES INTEGRATION_PARAMS (ID)
);
CREATE UNIQUE INDEX INTEGRATION_SETTINGS_INTEGRATION_PARAM_ID_INTEGRATION_ID_UNIQUE ON INTEGRATION_SETTINGS (INTEGRATION_PARAM_ID, INTEGRATION_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_INTEGRATION_SETTINGS
    BEFORE INSERT OR UPDATE
    ON INTEGRATION_SETTINGS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS JOBS;
CREATE TABLE IF NOT EXISTS JOBS
(
    ID                   SERIAL,
    USER_ID              INT          NULL,
    NAME                 VARCHAR(100) NOT NULL,
    JOB_URL              VARCHAR(255) NOT NULL,
    JENKINS_HOST         VARCHAR(255) NULL,
    AUTOMATION_SERVER_ID INT          NULL,
    MODIFIED_AT          TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT           TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (USER_ID) REFERENCES USERS (ID),
    FOREIGN KEY (AUTOMATION_SERVER_ID) REFERENCES INTEGRATIONS (ID)
);
CREATE UNIQUE INDEX JOB_URL_UNIQUE ON JOBS (JOB_URL);
CREATE INDEX FK_JOBS_USERS1_IDX ON JOBS (USER_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_JOBS
    BEFORE INSERT OR UPDATE
    ON JOBS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS TEST_CONFIGS;
CREATE TABLE IF NOT EXISTS TEST_CONFIGS
(
    ID               SERIAL,
    URL              VARCHAR(512) NULL,
    ENV              VARCHAR(50)  NULL,
    PLATFORM         VARCHAR(30)  NULL,
    PLATFORM_VERSION VARCHAR(30)  NULL,
    BROWSER          VARCHAR(30)  NULL,
    BROWSER_VERSION  VARCHAR(30)  NULL,
    APP_VERSION      VARCHAR(255) NULL,
    LOCALE           VARCHAR(30)  NULL,
    LANGUAGE         VARCHAR(30)  NULL,
    DEVICE           VARCHAR(50)  NULL,
    MODIFIED_AT      TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT       TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);
CREATE TRIGGER UPDATE_TIMESTAMP_TEST_CONFIGS
    BEFORE INSERT OR UPDATE
    ON TEST_CONFIGS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS TEST_RUNS;
CREATE TABLE IF NOT EXISTS TEST_RUNS
(
    ID                        SERIAL,
    CI_RUN_ID                 VARCHAR(50)  NULL,
    USER_ID                   INT,
    TEST_SUITE_ID             INT          NOT NULL,
    STATUS                    VARCHAR(20)  NOT NULL,
    SCM_URL                   VARCHAR(255) NULL,
    SCM_BRANCH                VARCHAR(100) NULL,
    SCM_COMMIT                VARCHAR(100) NULL,
    CONFIG_XML                TEXT         NULL,
    WORK_ITEM_ID              INT          NULL,
    JOB_ID                    INT          NULL,
    BUILD_NUMBER              INT          NOT NULL,
    STARTED_BY                VARCHAR(45)  NULL,
    UPSTREAM_JOB_ID           INT          NULL,
    UPSTREAM_JOB_BUILD_NUMBER INT          NULL,
    PROJECT_ID                INT          NULL,
    CONFIG_ID                 INT          NULL,
    KNOWN_ISSUE               BOOLEAN      NOT NULL DEFAULT FALSE,
    BLOCKER                   BOOLEAN      NOT NULL DEFAULT FALSE,
    ENV                       VARCHAR(50)  NULL,
    APP_VERSION               VARCHAR(255) NULL,
    STARTED_AT                TIMESTAMP    NULL,
    ENDED_AT                  TIMESTAMP    NULL,
    ELAPSED                   INT          NULL,
    ETA                       INT          NULL,
    COMMENTS                  TEXT         NULL,
    CHANNELS                  VARCHAR(255) NULL,
    REVIEWED                  BOOLEAN      NOT NULL DEFAULT FALSE,
    FRAMEWORK                 VARCHAR(50)  NULL,
    MODIFIED_AT               TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT                TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (USER_ID) REFERENCES USERS (ID),
    FOREIGN KEY (TEST_SUITE_ID) REFERENCES TEST_SUITES (ID),
    FOREIGN KEY (WORK_ITEM_ID) REFERENCES WORK_ITEMS (ID),
    FOREIGN KEY (JOB_ID) REFERENCES JOBS (ID),
    FOREIGN KEY (UPSTREAM_JOB_ID) REFERENCES JOBS (ID),
    FOREIGN KEY (PROJECT_ID) REFERENCES PROJECTS (ID),
    FOREIGN KEY (CONFIG_ID) REFERENCES TEST_CONFIGS (ID)
);
CREATE INDEX FK_TEST_RUN_USER_ASC ON TEST_RUNS (USER_ID);
CREATE INDEX FK_TEST_RUN_TEST_SUITE_ASC ON TEST_RUNS (TEST_SUITE_ID);
CREATE INDEX FK_TEST_RUNS_WORK_ITEMS1_IDX ON TEST_RUNS (WORK_ITEM_ID);
CREATE INDEX FK_TEST_RUNS_JOBS1_IDX ON TEST_RUNS (JOB_ID);
CREATE INDEX FK_TEST_RUNS_JOBS2_IDX ON TEST_RUNS (UPSTREAM_JOB_ID);
CREATE INDEX FK_TEST_RUNS_PROJECTS1_IDX ON TEST_RUNS (PROJECT_ID);
CREATE INDEX TEST_RUNS_STARTED_AT_INDEX ON TEST_RUNS (STARTED_AT ASC NULLS LAST);
CREATE UNIQUE INDEX CI_RUN_ID_UNIQUE ON TEST_RUNS (CI_RUN_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_TEST_RUNS
    BEFORE INSERT OR UPDATE
    ON TEST_RUNS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();

DROP TABLE IF EXISTS TEST_RUN_ARTIFACTS;
CREATE TABLE IF NOT EXISTS TEST_RUN_ARTIFACTS
(
    ID          SERIAL,
    NAME        VARCHAR(255) NOT NULL,
    LINK        TEXT         NOT NULL,
    EXPIRES_AT  TIMESTAMP    NULL,
    TEST_RUN_ID INT          NOT NULL,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_RUN_ID) REFERENCES TEST_RUNS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);
CREATE INDEX FK_TEST_RUN_ARTIFACTS_TEST_RUNS_IDX ON TEST_RUN_ARTIFACTS (TEST_RUN_ID);
CREATE UNIQUE INDEX NAME_TEST_RUN_ID_UNIQUE ON TEST_RUN_ARTIFACTS (NAME, TEST_RUN_ID);

DROP TABLE IF EXISTS TESTS;
CREATE TABLE IF NOT EXISTS TESTS
(
    ID                 SERIAL,
    CI_TEST_ID         VARCHAR(50)  NULL,
    NAME               VARCHAR(255) NOT NULL,
    STATUS             VARCHAR(20)  NOT NULL,
    TEST_ARGS          TEXT         NULL,
    TEST_RUN_ID        INT          NOT NULL,
    TEST_CASE_ID       INT          NOT NULL,
    TEST_GROUP         VARCHAR(255),
    MESSAGE            TEXT         NULL,
    MESSAGE_HASH_CODE  INT          NULL,
    START_TIME         TIMESTAMP    NULL,
    FINISH_TIME        TIMESTAMP    NULL,
    RETRY              INT          NOT NULL DEFAULT 0,
    TEST_CONFIG_ID     INT          NULL,
    KNOWN_ISSUE        BOOLEAN      NOT NULL DEFAULT FALSE,
    BLOCKER            BOOLEAN      NOT NULL DEFAULT FALSE,
    NEED_RERUN         BOOLEAN      NOT NULL DEFAULT TRUE,
    DEPENDS_ON_METHODS VARCHAR(255) NULL,
    UUID               TEXT         NULL,
    MODIFIED_AT        TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT         TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_CONFIG_ID) REFERENCES TEST_CONFIGS (ID),
    FOREIGN KEY (TEST_RUN_ID) REFERENCES TEST_RUNS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASES (ID)
);
CREATE UNIQUE INDEX UUID_TEST_UNIQUE ON TESTS (TEST_RUN_ID, UUID) WHERE UUID IS NOT NULL;
CREATE INDEX FK_TESTS_TEST_RUNS1_IDX ON TESTS (TEST_RUN_ID);
CREATE INDEX FK_TESTS_TEST_CASES1_IDX ON TESTS (TEST_CASE_ID);
CREATE INDEX FK_TESTS_TEST_CONFIGS1_IDX ON TESTS (TEST_CONFIG_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_TESTS
    BEFORE INSERT OR UPDATE
    ON TESTS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS TAGS;
CREATE TABLE IF NOT EXISTS TAGS
(
    ID          SERIAL,
    NAME        VARCHAR(50)  NOT NULL,
    VALUE       VARCHAR(255) NOT NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX TAGS_UNIQUE ON TAGS (NAME, VALUE);
CREATE INDEX TAGS_NAME ON TAGS (NAME);
CREATE INDEX TAGS_VALUE ON TAGS (VALUE);
CREATE TRIGGER UPDATE_TIMESTAMP_TAGS
    BEFORE INSERT OR UPDATE
    ON TAGS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();

DROP TABLE IF EXISTS TEST_TAGS;
CREATE TABLE IF NOT EXISTS TEST_TAGS
(
    ID          SERIAL,
    TEST_ID     INT       NOT NULL,
    TAG_ID      INT       NOT NULL,
    MODIFIED_AT TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_ID) REFERENCES TESTS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (TAG_ID) REFERENCES TAGS (ID)
);
CREATE INDEX FK_TESTS_TEST_TAGS1_IDX ON TEST_TAGS (TEST_ID);
CREATE INDEX FK_TAGS_TEST_TAGS1_IDX ON TEST_TAGS (TAG_ID);
CREATE UNIQUE INDEX TEST_TAGS_UNIQUE ON TEST_TAGS (TAG_ID, TEST_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_TEST_TAGS
    BEFORE INSERT OR UPDATE
    ON TEST_TAGS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();

DROP TABLE IF EXISTS TEST_ARTIFACTS;
CREATE TABLE IF NOT EXISTS TEST_ARTIFACTS
(
    ID          SERIAL,
    NAME        VARCHAR(255) NOT NULL,
    LINK        TEXT         NOT NULL,
    EXPIRES_AT  TIMESTAMP    NULL,
    TEST_ID     INT          NOT NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_ID) REFERENCES TESTS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);
CREATE INDEX FK_TEST_ARTIFACTS_TESTS1_IDX ON TEST_ARTIFACTS (TEST_ID);
CREATE UNIQUE INDEX NAME_TEST_ID_UNIQUE ON TEST_ARTIFACTS (NAME, TEST_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_TEST_ARTIFACTS
    BEFORE INSERT OR UPDATE
    ON TEST_ARTIFACTS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();



DROP TABLE IF EXISTS TEST_WORK_ITEMS;
CREATE TABLE IF NOT EXISTS TEST_WORK_ITEMS
(
    ID           SERIAL,
    TEST_ID      INT       NOT NULL,
    WORK_ITEM_ID INT       NOT NULL,
    MODIFIED_AT  TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT   TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_ID) REFERENCES TESTS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (WORK_ITEM_ID) REFERENCES WORK_ITEMS (ID)
);
CREATE UNIQUE INDEX TEST_WORK_ITEM_TEST_ID_WORK_ITEM_ID_UNIQUE ON TEST_WORK_ITEMS (TEST_ID, WORK_ITEM_ID);
CREATE INDEX FK_TEST_WORK_ITEMS_TESTS1_IDX ON TEST_WORK_ITEMS (TEST_ID);
CREATE INDEX FK_TEST_WORK_ITEMS_WORK_ITEMS1_IDX ON TEST_WORK_ITEMS (WORK_ITEM_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_TEST_WORK_ITEMS
    BEFORE INSERT OR UPDATE
    ON TEST_WORK_ITEMS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS TEST_METRICS;
CREATE TABLE IF NOT EXISTS TEST_METRICS
(
    ID          SERIAL,
    OPERATION   VARCHAR(127) NOT NULL,
    ELAPSED     BIGINT       NOT NULL,
    TEST_ID     INT          NOT NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_ID) REFERENCES TESTS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);
CREATE INDEX FK_TEST_METRICS_TESTS1_IDX ON TEST_METRICS (TEST_ID);
CREATE INDEX TEST_OPERATION ON TEST_METRICS (OPERATION);
CREATE TRIGGER UPDATE_TIMESTAMP_TEST_METRICS
    BEFORE INSERT OR UPDATE
    ON TEST_METRICS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS SETTINGS;
CREATE TABLE IF NOT EXISTS SETTINGS
(
    ID           SERIAL,
    NAME         VARCHAR(255) NOT NULL,
    VALUE        TEXT         NULL,
    IS_ENCRYPTED BOOLEAN      NULL     DEFAULT FALSE,
    TOOL         VARCHAR(255) NULL,
    FILE         BYTEA        NULL,
    MODIFIED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT   TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX SETTING_UNIQUE ON SETTINGS (NAME);
CREATE TRIGGER UPDATE_TIMESTAMP_SETTINGS
    BEFORE INSERT OR UPDATE
    ON SETTINGS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS WIDGETS;
CREATE TABLE IF NOT EXISTS WIDGETS
(
    ID                 SERIAL,
    TITLE              VARCHAR(255) NOT NULL,
    DESCRIPTION        VARCHAR(255) NULL,
    PARAMS_CONFIG      TEXT         NULL,
    LEGEND_CONFIG      TEXT         NULL,
    WIDGET_TEMPLATE_ID INT          NULL,
    REFRESHABLE        BOOLEAN      NOT NULL DEFAULT FALSE NOT NULL,
    MODIFIED_AT        TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT         TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    TYPE               VARCHAR(20)  NULL,
    SQL                TEXT         NULL,
    MODEL              TEXT         NULL,
    PRIMARY KEY (ID),
    FOREIGN KEY (WIDGET_TEMPLATE_ID) REFERENCES MANAGEMENT.WIDGET_TEMPLATES (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);
CREATE UNIQUE INDEX WIDGETS_TITLE_WIDGET_TEMPLATE_ID_UINDEX ON WIDGETS (TITLE, WIDGET_TEMPLATE_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_WIDGETS
    BEFORE INSERT OR UPDATE
    ON WIDGETS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS DASHBOARDS;
CREATE TABLE IF NOT EXISTS DASHBOARDS
(
    ID          SERIAL,
    TITLE       VARCHAR(255) NOT NULL,
    HIDDEN      BOOLEAN      NOT NULL DEFAULT FALSE,
    POSITION    INT          NOT NULL DEFAULT 0,
    EDITABLE    BOOLEAN      NOT NULL DEFAULT TRUE,
    SYSTEM      BOOLEAN      NOT NULL DEFAULT FALSE,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);
CREATE INDEX TITLE_UNIQUE ON DASHBOARDS (TITLE);
CREATE TRIGGER UPDATE_TIMESTAMP_DASHBOARDS
    BEFORE INSERT OR UPDATE
    ON DASHBOARDS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS DASHBOARDS_WIDGETS;
CREATE TABLE IF NOT EXISTS DASHBOARDS_WIDGETS
(
    ID           SERIAL,
    DASHBOARD_ID INT          NOT NULL,
    WIDGET_ID    INT          NOT NULL,
    POSITION     INT          NULL     DEFAULT 0,
    SIZE         INT          NULL     DEFAULT 1,
    LOCATION     VARCHAR(255) NOT NULL DEFAULT '',
    MODIFIED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT   TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (DASHBOARD_ID) REFERENCES DASHBOARDS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (WIDGET_ID) REFERENCES WIDGETS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);
CREATE INDEX FK_DASHBOARDS_WIDGETS_DASHBOARDS1_IDX ON DASHBOARDS_WIDGETS (DASHBOARD_ID);
CREATE INDEX FK_DASHBOARDS_WIDGETS_WIDGETS1_IDX ON DASHBOARDS_WIDGETS (WIDGET_ID);
CREATE UNIQUE INDEX DASHBOARD_WIDGET_UNIQUE ON DASHBOARDS_WIDGETS (DASHBOARD_ID, WIDGET_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_DASHBOARDS_WIDGETS
    BEFORE INSERT OR UPDATE
    ON DASHBOARDS_WIDGETS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();

DROP TABLE IF EXISTS DASHBOARD_ATTRIBUTES;
CREATE TABLE IF NOT EXISTS DASHBOARD_ATTRIBUTES
(
    ID           SERIAL,
    KEY          VARCHAR(255) NOT NULL,
    VALUE        VARCHAR(255) NOT NULL,
    DASHBOARD_ID INT          NOT NULL,
    MODIFIED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT   TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (DASHBOARD_ID) REFERENCES DASHBOARDS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);
CREATE INDEX FK_DASHBOARD_ATTRIBUTES_DASHBOARDS1_IDX ON DASHBOARD_ATTRIBUTES (DASHBOARD_ID);
CREATE UNIQUE INDEX DASHBOARD_KEY_UNIQUE ON DASHBOARD_ATTRIBUTES (KEY, DASHBOARD_ID);
CREATE TRIGGER UPDATE_TIMESTAMP_DASHBOARD_ATTRIBUTES
    BEFORE INSERT OR UPDATE
    ON DASHBOARD_ATTRIBUTES
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();

DROP TABLE IF EXISTS FILTERS;

CREATE TABLE IF NOT EXISTS FILTERS
(
    ID            SERIAL,
    NAME          VARCHAR(50) NOT NULL,
    DESCRIPTION   TEXT        NULL,
    SUBJECT       TEXT        NOT NULL,
    PUBLIC_ACCESS BOOLEAN     NOT NULL DEFAULT FALSE,
    USER_ID       INT         NOT NULL,
    MODIFIED_AT   TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT    TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX FILTERS_NAME_PUBLIC_UNIQUE ON FILTERS (NAME) WHERE PUBLIC_ACCESS = TRUE;
CREATE UNIQUE INDEX FILTERS_NAME_USER_ID_PUBLIC_ACCESS_PRIVATE_UNIQUE ON FILTERS (NAME, USER_ID, PUBLIC_ACCESS) WHERE PUBLIC_ACCESS = FALSE;
CREATE TRIGGER UPDATE_TIMESTAMP_FILTERS
    BEFORE INSERT OR UPDATE
    ON FILTERS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS SCM;

CREATE TABLE IF NOT EXISTS SCM
(
    ID             SERIAL,
    NAME           VARCHAR(50)  NOT NULL,
    LOGIN          VARCHAR(255) NULL,
    ACCESS_TOKEN   VARCHAR(255) NOT NULL,
    ORGANIZATION   VARCHAR(255) NULL,
    REPO           VARCHAR(255) NULL,
    REPOSITORY_URL VARCHAR(255) NULL,
    USER_ID        INT          NULL,
    AVATAR_URL     VARCHAR(255) NULL,
    API_VERSION    VARCHAR(255) NULL,
    MODIFIED_AT    TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT     TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);
CREATE TRIGGER UPDATE_TIMESTAMP_SCM
    BEFORE INSERT OR UPDATE
    ON SCM
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS LAUNCHERS;

CREATE TABLE IF NOT EXISTS LAUNCHERS
(
    ID          SERIAL,
    NAME        VARCHAR(255) NOT NULL,
    MODEL       TEXT         NOT NULL,
    SCM_ID      INT          NOT NULL,
    JOB_ID      INT          NULL,
    TYPE        VARCHAR(50),
    AUTO_SCAN   BOOLEAN      NOT NULL DEFAULT FALSE,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (SCM_ID) REFERENCES SCM (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (JOB_ID) REFERENCES JOBS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);
CREATE TRIGGER UPDATE_TIMESTAMP_LAUNCHERS
    BEFORE INSERT OR UPDATE
    ON LAUNCHERS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS LAUNCHER_PRESETS;
CREATE TABLE IF NOT EXISTS LAUNCHER_PRESETS
(
    ID          SERIAL,
    NAME        VARCHAR(50) NOT NULL,
    REFERENCE   VARCHAR(20) NOT NULL,
    PARAMS      TEXT        NULL,
    LAUNCHER_ID INT         NOT NULL,
    PROVIDER_ID INT         NOT NULL,
    MODIFIED_AT TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    CONSTRAINT FK_LAUNCHER_PRESET_LAUNCHERS1
        FOREIGN KEY (LAUNCHER_ID)
            REFERENCES LAUNCHERS (ID)
            ON DELETE CASCADE
            ON UPDATE NO ACTION,
    CONSTRAINT FK_LAUNCHER_PRESET_INTEGRATIONS1
        FOREIGN KEY (PROVIDER_ID)
            REFERENCES INTEGRATIONS (ID)
            ON DELETE CASCADE
            ON UPDATE NO ACTION
);
CREATE UNIQUE INDEX LAUNCHER_PRESET_LAUNCHER_ID_NAME_UNIQUE ON LAUNCHER_PRESETS (NAME, LAUNCHER_ID);
CREATE UNIQUE INDEX LAUNCHER_PRESET_REFERENCE_UNIQUE ON LAUNCHER_PRESETS (REFERENCE);
CREATE TRIGGER UPDATE_TIMESTAMP_LAUNCHER_PRESETS
    BEFORE INSERT OR UPDATE
    ON LAUNCHER_PRESETS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


DROP TABLE IF EXISTS LAUNCHER_CALLBACKS;
CREATE TABLE IF NOT EXISTS LAUNCHER_CALLBACKS
(
    ID                 SERIAL,
    CI_RUN_ID          VARCHAR(50)  NOT NULL,
    URL                VARCHAR(255) NOT NULL,
    REFERENCE          VARCHAR(20)  NOT NULL,
    LAUNCHER_PRESET_ID INT          NOT NULL,
    MODIFIED_AT        TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT         TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    CONSTRAINT FK_LAUNCHER_CALLBACK_LAUNCHER_PRESETS1
        FOREIGN KEY (LAUNCHER_PRESET_ID)
            REFERENCES LAUNCHER_PRESETS (ID)
            ON DELETE CASCADE
            ON UPDATE NO ACTION
);
CREATE UNIQUE INDEX LAUNCHER_CALLBACK_CI_RUN_ID_UNIQUE ON LAUNCHER_CALLBACKS (CI_RUN_ID);
CREATE UNIQUE INDEX LAUNCHER_CALLBACK_REFERENCE_UNIQUE ON LAUNCHER_CALLBACKS (REFERENCE);
CREATE TRIGGER UPDATE_TIMESTAMP_LAUNCHER_CALLBACK
    BEFORE INSERT OR UPDATE
    ON LAUNCHER_CALLBACKS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();


CREATE TABLE IF NOT EXISTS USER_LAUNCHER_PREFERENCES
(
    ID          SERIAL,
    USER_ID     INT     NOT NULL,
    LAUNCHER_ID INT     NOT NULL,
    FAVORITE    BOOLEAN NULL DEFAULT FALSE,
    PRIMARY KEY (ID),
    FOREIGN KEY (USER_ID) REFERENCES USERS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (LAUNCHER_ID) REFERENCES LAUNCHERS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);
CREATE UNIQUE INDEX USER_LAUNCHER_PREFERENCES_USER_ID_LAUNCHER_ID_UNIQUE ON USER_LAUNCHER_PREFERENCES (USER_ID, LAUNCHER_ID);


DROP TABLE IF EXISTS TEST_SESSIONS;
CREATE TABLE TEST_SESSIONS
(
    ID           SERIAL,
    SESSION_ID   VARCHAR(255) NOT NULL,
    VERSION      VARCHAR(255) NOT NULL,
    STARTED_AT   TIMESTAMP    NOT NULL,
    ENDED_AT     TIMESTAMP    NULL,
    DURATION     INT          NULL,
    OS_NAME      VARCHAR(255) NOT NULL,
    BROWSER_NAME VARCHAR(255) NOT NULL,
    TEST_NAME    VARCHAR(255) NULL,
    BUILD_NUMBER VARCHAR(255) NULL,
    STATUS       VARCHAR(20)  NOT NULL,
    MODIFIED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT   TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);
CREATE TRIGGER UPDATE_TIMESTAMP_TEST_SESSIONS
    BEFORE INSERT OR UPDATE
    ON TEST_SESSIONS
    FOR EACH ROW
EXECUTE PROCEDURE UPDATE_MODIFIED_AT();
